Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/BBCBillboardCloudUVMapper.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/BBCBillboardCloudUVMapper.cpp	(revision 745)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/BBCBillboardCloudUVMapper.cpp	(revision 751)
@@ -118,12 +118,6 @@
 }
 
-void BillboardCloudUVMapper::addTextureAtlasTextureCoords(bool mergeBillboards, bool groupedBillboards, unsigned int numGeneratedBillboardClouds, unsigned int iBillboardGroup, unsigned int iBillboard)
-{
-	unsigned int iUniqueVertex = 0;
-
-	Ogre::LogManager::getSingleton().logMessage("iBBC:" + Ogre::StringConverter::toString(numGeneratedBillboardClouds) + "-" + "iBBCG:" + Ogre::StringConverter::toString(iBillboardGroup));
-
-	Ogre::LogManager::getSingleton().logMessage("SizeCLList:" + Ogre::StringConverter::toString(getClusterList(iBillboardGroup)->getSize()) + " -- numBBC:" + Ogre::StringConverter::toString(numGeneratedBillboardClouds));
-
+void BillboardCloudUVMapper::addTextureAtlasTextureCoords(bool mergeBillboards, bool groupedBillboards, unsigned int numGeneratedBillboards, unsigned int iBillboardGroup, unsigned int iBillboard, unsigned int iBillboardInGroup)
+{
 	IMG::Cluster *cluster = getClusterList(iBillboardGroup)->get(getClusterList(iBillboardGroup)->getSize()-1);		
 	IMG::Box2d *box = cluster->getBspNodeBound();
@@ -131,7 +125,4 @@
 	Ogre::Vector2 min = box->getMinimum();
 
-	Ogre::LogManager::getSingleton().logMessage("max:" + Ogre::StringConverter::toString(Ogre::Vector3(max[0], max[1], 0.0)) );
-	Ogre::LogManager::getSingleton().logMessage("min:" + Ogre::StringConverter::toString(Ogre::Vector3(min[0], min[1], 0.0)) );
-
 	Ogre::Vector2 umax;
 	umax[0] = (max[0] / mTextureAtlasWidth);
@@ -145,44 +136,43 @@
 	umax = umax * 2.0 - 1.0;
 
-	Ogre::LogManager::getSingleton().logMessage("Umax:" + Ogre::StringConverter::toString(Ogre::Vector3(umax[0], umax[1], 0.0)) );
-	Ogre::LogManager::getSingleton().logMessage("Umin:" + Ogre::StringConverter::toString(Ogre::Vector3(umin[0], umin[1], 0.0)) );
-	
+	mBillboardCloud->getBillboard(iBillboard)->getBillboardClusterData()->addBillboardUVMapMax(umax);
 	mBillboardCloud->getBillboard(iBillboard)->getBillboardClusterData()->addBillboardUVMapMin(umin);
-	mBillboardCloud->getBillboard(iBillboard)->getBillboardClusterData()->addBillboardUVMapMax(umax);
-
-	Ogre::LogManager::getSingleton().logMessage("Max:" + Ogre::StringConverter::toString(Ogre::Vector3(max[0],max[1],0)) + 
-		"\tMin:" + Ogre::StringConverter::toString(Ogre::Vector3(min[0],min[1],0)) + 
-		"\tSize(" + Ogre::StringConverter::toString(max[0]-min[0]) +
-		"," + Ogre::StringConverter::toString(max[1]-min[1]) + ")");
-
-	Ogre::LogManager::getSingleton().logMessage(
-		"UMax:" + Ogre::StringConverter::toString(Ogre::Vector3(umax[0], umax[1],0)) + 
-		"\tUMin:" + Ogre::StringConverter::toString(Ogre::Vector3(umin[0], umin[1],0)) + 
-		"\tUSize(" + Ogre::StringConverter::toString(umax[0]-umin[0]) +
-		"," + Ogre::StringConverter::toString(umax[1]-umin[1]) + ")");
-
-	std::cin.get();
-
-
-	SubEntityPtr subEntity;												
+
+	//Ogre::LogManager::getSingleton().logMessage("Max:" + Ogre::StringConverter::toString(Ogre::Vector3(max[0],max[1],0)) + 
+	//	"\tMin:" + Ogre::StringConverter::toString(Ogre::Vector3(min[0],min[1],0)) + 
+	//	"\tSize(" + Ogre::StringConverter::toString(max[0]-min[0]) +
+	//	"," + Ogre::StringConverter::toString(max[1]-min[1]) + ")");
+
+	//Ogre::LogManager::getSingleton().logMessage(
+	//	"UMax:" + Ogre::StringConverter::toString(Ogre::Vector3(umax[0], umax[1],0)) + 
+	//	"\tUMin:" + Ogre::StringConverter::toString(Ogre::Vector3(umin[0], umin[1],0)) + 
+	//	"\tUSize(" + Ogre::StringConverter::toString(umax[0]-umin[0]) +
+	//	"," + Ogre::StringConverter::toString(umax[1]-umin[1]) + ")");
 	
 	Ogre::Vector2 texCoords01,texCoords02,texCoords03,texCoords04;
-	texCoords01[0] = min[0] / mTextureAtlasWidth;
-	texCoords01[1] = min[1] / mTextureAtlasHeight;
-
-	texCoords02[0] = max[0] / mTextureAtlasWidth;
-	texCoords02[1] = min[1] / mTextureAtlasHeight;
-
-	texCoords03[0] = max[0] / mTextureAtlasWidth;
-	texCoords03[1] = max[1] / mTextureAtlasHeight;
-
-	texCoords04[0] = min[0] / mTextureAtlasWidth;
-	texCoords04[1] = max[1] / mTextureAtlasHeight;
+
+	texCoords02[0] = min[0] / mTextureAtlasWidth;
+	texCoords02[1] = 1.0 - (min[1] / mTextureAtlasHeight);
+
+	texCoords01[0] = max[0] / mTextureAtlasWidth;
+	texCoords01[1] = 1.0 - (min[1] / mTextureAtlasHeight);
+
+	texCoords04[0] = max[0] / mTextureAtlasWidth;
+	texCoords04[1] = 1.0 - (max[1] / mTextureAtlasHeight);
+
+	texCoords03[0] = min[0] / mTextureAtlasWidth;
+	texCoords03[1] = 1.0 - (max[1] / mTextureAtlasHeight);
 	
 	if (groupedBillboards)
 	{
-		Ogre::LogManager::getSingleton().logMessage("DontMerge");
-		subEntity = mBillboardCloud->getEntity()->getSubEntity(iBillboardGroup);				
-		
+		SubEntityPtr subEntity;												
+
+		unsigned int iUniqueVertex = 0;
+
+		subEntity = mBillboardCloud->getEntity()->getSubEntity(numGeneratedBillboards);				
+
+		subEntity->addTextureCoordSet(2);
+		subEntity->enableVertexColours(true);
+
 		// Face A
 		//(0,0,0);
@@ -216,53 +206,12 @@
 		subEntity->setVertexColour(iUniqueVertex+4, subEntityColour05.getAsRGBA());
 		subEntity->setVertexColour(iUniqueVertex+5, subEntityColour06.getAsRGBA());
-
-		iUniqueVertex = iUniqueVertex + 6;
 	}
 	else
 	{
-		if (!mergeBillboards)
-		{
-			Ogre::LogManager::getSingleton().logMessage("DontMerge");
-
-			subEntity = mBillboardCloud->getEntity()->getSubEntity(numGeneratedBillboardClouds);
-			subEntity->addTextureCoordSet(2);
-			subEntity->enableVertexColours(true);
-			// Face A
-			//(0,0,0);
-			//(1,0,0);
-			//(1,1,0);
-
-			subEntity->setTexCoord(0, subEntity->getNumTexCoordSets()-1, Ogre::Vector3(texCoords01[0],texCoords01[1], 0));
-			subEntity->setTexCoord(1, subEntity->getNumTexCoordSets()-1, Ogre::Vector3(texCoords02[0],texCoords02[1], 0));
-			subEntity->setTexCoord(2, subEntity->getNumTexCoordSets()-1, Ogre::Vector3(texCoords03[0],texCoords03[1], 0));
-
-			Ogre::ColourValue subEntityColour01 = Ogre::ColourValue(0, texCoords01[0],texCoords01[1]);
-			Ogre::ColourValue subEntityColour02 = Ogre::ColourValue(0, texCoords02[0],texCoords02[1]);
-			Ogre::ColourValue subEntityColour03 = Ogre::ColourValue(0, texCoords03[0],texCoords03[1]);
-
-			subEntity->setVertexColour(0, subEntityColour01.getAsRGBA());
-			subEntity->setVertexColour(1, subEntityColour02.getAsRGBA());
-			subEntity->setVertexColour(2, subEntityColour03.getAsRGBA());
-
-			// Face B
-			//(1,1,0);
-			//(0,1,0);
-			//(0,0,0);
-			subEntity->setTexCoord(3, subEntity->getNumTexCoordSets()-1, Ogre::Vector3(texCoords03[0],texCoords03[1],0));
-			subEntity->setTexCoord(4, subEntity->getNumTexCoordSets()-1, Ogre::Vector3(texCoords04[0],texCoords04[1],0));
-			subEntity->setTexCoord(5, subEntity->getNumTexCoordSets()-1, Ogre::Vector3(texCoords01[0],texCoords01[1],0));
-
-			Ogre::ColourValue subEntityColour04 = Ogre::ColourValue(0, texCoords03[0],texCoords03[1]);
-			Ogre::ColourValue subEntityColour05 = Ogre::ColourValue(0, texCoords04[0],texCoords04[1]);
-			Ogre::ColourValue subEntityColour06 = Ogre::ColourValue(0, texCoords01[0],texCoords01[1]);
-
-			subEntity->setVertexColour(3, subEntityColour04.getAsRGBA());
-			subEntity->setVertexColour(4, subEntityColour05.getAsRGBA());
-			subEntity->setVertexColour(5, subEntityColour06.getAsRGBA());
-
-		}
-		else
-		{
-			Ogre::LogManager::getSingleton().logMessage("Merge");
+		if (mergeBillboards)
+		{
+			SubEntityPtr subEntity;	
+
+			unsigned int iUniqueVertex = numGeneratedBillboards * 6;
 
 			subEntity = mBillboardCloud->getEntity()->getSubEntity(0);				
@@ -300,7 +249,5 @@
 			subEntity->setVertexColour(iUniqueVertex+5, subEntityColour06.getAsRGBA());
 
-			iUniqueVertex = iUniqueVertex + 6;
-		}
-		Ogre::LogManager::getSingleton().logMessage("EndAdd");
+		}
 	}
 }
@@ -310,10 +257,8 @@
 	IMG::NodeBspPtr nodeDest;
 	IMG::Cluster cluster;
-	Ogre::LogManager::getSingleton().logMessage("w:" + Ogre::StringConverter::toString(mTextureWidth));
-	Ogre::LogManager::getSingleton().logMessage("h:" + Ogre::StringConverter::toString(mTextureHeight));
+
 	nodeDest = getBsp(iBillboardGroup)->insert(mTextureWidth,mTextureHeight,iBillboard);
 	
 	cluster.setBspNodeBound(nodeDest->getBound());
-	//cluster.finish();
 	getClusterList(iBillboardGroup)->insert(&cluster);	
 }
@@ -323,5 +268,5 @@
 	unsigned int numBillboardGroups;
 	bool enabledTextureCoordSet = false;
-	unsigned int numGeneratedBillboardClouds = 0;
+	unsigned int numGeneratedBillboards = 0;
 
 	for (unsigned int iBillboard = 0; iBillboard < mBillboardCloud->getNumBillboards(); iBillboard++)
@@ -342,15 +287,5 @@
 				}
 			}
-			else
-			{
-				if (groupedBillboards)
-				{
-					SubEntityPtr subEntity = mBillboardCloud->getEntity()->getSubEntity(numGeneratedBillboardClouds);	
-					subEntity->addTextureCoordSet(2);
-					subEntity->enableVertexColours(true);
-				}
-			}
-
-			numGeneratedBillboardClouds++;
+			numGeneratedBillboards++;
 		}
 	}
@@ -373,7 +308,7 @@
 	
 	unsigned int iBillboardsInGroup = 0;
-	unsigned int numberBillboardsEachGroup = numGeneratedBillboardClouds / numGroups;
-	unsigned int numberBillboardsAddedFirstGroup = numGeneratedBillboardClouds % numGroups;
-	numGeneratedBillboardClouds = 0;
+	unsigned int numberBillboardsEachGroup = numGeneratedBillboards / numGroups;
+	unsigned int numberBillboardsAddedFirstGroup = numGeneratedBillboards % numGroups;
+	numGeneratedBillboards = 0;
 	unsigned int iBillboardGroup;
 	for (iBillboardGroup = 0; iBillboardGroup < numBillboardGroups; iBillboardGroup++)
@@ -388,5 +323,4 @@
 		addBsp(bsp);
 		addClusterList(clusterList);
-
 	}
 
@@ -400,17 +334,13 @@
 		if (billboardClusterData != NULL)
 		{
-			Ogre::LogManager::getSingleton().logMessage("billboardData");
+			BillboardPtr billboard = mBillboardCloud->getBillboard(iBillboard);		
 			EntityClusterPtr entityCluster = billboardClusterData->getEntityCluster();
+
 			if (entityCluster->getNumEntitiesClusterData() > 0)
 			{			
-				Ogre::LogManager::getSingleton().logMessage("entityCluster");
-				
 				if ((iBillboardGroup == 0) && (iBillboardsInGroup < (numberBillboardsEachGroup + numberBillboardsAddedFirstGroup)))
 				{
-					Ogre::LogManager::getSingleton().logMessage("\nA");
-					Ogre::LogManager::getSingleton().logMessage("IG:" + Ogre::StringConverter::toString(iBillboardsInGroup) + " SizeCLList(" + Ogre::StringConverter::toString(iBillboardGroup) + "):" + Ogre::StringConverter::toString(getClusterList(iBillboardGroup)->getSize()) + " -- numBBC:" + Ogre::StringConverter::toString(numGeneratedBillboardClouds));
-
 					addTextureInBsp(iBillboardGroup, iBillboard);
-					addTextureAtlasTextureCoords(mergeBillboards, groupedBillboards, numGeneratedBillboardClouds, iBillboardGroup, iBillboard);
+					addTextureAtlasTextureCoords(mergeBillboards, groupedBillboards, numGeneratedBillboards, iBillboardGroup, iBillboard, iBillboardsInGroup);
 					iBillboardsInGroup++;
 				}
@@ -419,9 +349,6 @@
 					if ((iBillboardGroup > 0) && (iBillboardsInGroup < numberBillboardsEachGroup))
 					{
-						Ogre::LogManager::getSingleton().logMessage("\nB");
-						Ogre::LogManager::getSingleton().logMessage("IG:" + Ogre::StringConverter::toString(iBillboardsInGroup) + " SizeCLList(" + Ogre::StringConverter::toString(iBillboardGroup) + "):" + Ogre::StringConverter::toString(getClusterList(iBillboardGroup)->getSize()) + " -- numBBC:" + Ogre::StringConverter::toString(numGeneratedBillboardClouds));
-
 						addTextureInBsp(iBillboardGroup, iBillboard);
-						addTextureAtlasTextureCoords(mergeBillboards, groupedBillboards, numGeneratedBillboardClouds, iBillboardGroup, iBillboard);
+						addTextureAtlasTextureCoords(mergeBillboards, groupedBillboards, numGeneratedBillboards, iBillboardGroup, iBillboard, iBillboardsInGroup);
 						iBillboardsInGroup++;
 					}
@@ -431,18 +358,14 @@
 						iBillboardsInGroup = 0;
 
-						Ogre::LogManager::getSingleton().logMessage("\nC IG:" + Ogre::StringConverter::toString(iBillboardsInGroup-1) + " SizeCLList(" + Ogre::StringConverter::toString(iBillboardGroup-1) + "):" + Ogre::StringConverter::toString(getClusterList(iBillboardGroup-1)->getSize()));
-						Ogre::LogManager::getSingleton().logMessage("IG:" + Ogre::StringConverter::toString(iBillboardsInGroup) + " SizeCLList(" + Ogre::StringConverter::toString(iBillboardGroup) + "):" + Ogre::StringConverter::toString(getClusterList(iBillboardGroup)->getSize()) + " -- numBBC:" + Ogre::StringConverter::toString(numGeneratedBillboardClouds));
-
 						addTextureInBsp(iBillboardGroup, iBillboard);
-						addTextureAtlasTextureCoords(mergeBillboards, groupedBillboards, numGeneratedBillboardClouds, iBillboardGroup, iBillboard);
+						addTextureAtlasTextureCoords(mergeBillboards, groupedBillboards, numGeneratedBillboards, iBillboardGroup, iBillboard, iBillboardsInGroup);
 						iBillboardsInGroup++;
 					}
 				}
 
-				numGeneratedBillboardClouds++;
+				numGeneratedBillboards++;
 			}
 		}
 	}	
-	//mBsp.Print();
 }
 
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/LBBCBillboardKMeansClusterData.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/LBBCBillboardKMeansClusterData.cpp	(revision 745)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/LBBCBillboardKMeansClusterData.cpp	(revision 751)
@@ -181,14 +181,26 @@
 	if (iBillboardGroup >= 0)
 	{		
+		//uvMapMin = billboardNode->ToElement()->InsertEndChild(TiXmlElement("uvMapMin"))->ToElement();
+		//Ogre::String sUvMapMinX = Ogre::StringConverter::toString(this->getBillboardUVMapMin(iBillboardGroup).x);
+		//uvMapMin->ToElement()->SetAttribute("x",sUvMapMinX.c_str());
+		//Ogre::String sUvMapMinY = Ogre::StringConverter::toString(this->getBillboardUVMapMin(iBillboardGroup).y);
+		//uvMapMin->ToElement()->SetAttribute("y",sUvMapMinY.c_str());
+
+		//uvMapMax = billboardNode->ToElement()->InsertEndChild(TiXmlElement("uvMapMax"))->ToElement();
+		//Ogre::String suvMapMaxX = Ogre::StringConverter::toString(this->getBillboardUVMapMax(iBillboardGroup).x);
+		//uvMapMax->ToElement()->SetAttribute("x",suvMapMaxX.c_str());
+		//Ogre::String suvMapMaxY = Ogre::StringConverter::toString(this->getBillboardUVMapMax(iBillboardGroup).y);
+		//uvMapMax->ToElement()->SetAttribute("y",suvMapMaxY.c_str());
+
 		uvMapMin = billboardNode->ToElement()->InsertEndChild(TiXmlElement("uvMapMin"))->ToElement();
-		Ogre::String sUvMapMinX = Ogre::StringConverter::toString(this->getBillboardUVMapMin(iBillboardGroup).x);
+		Ogre::String sUvMapMinX = Ogre::StringConverter::toString(this->getBillboardUVMapMin(0).x);
 		uvMapMin->ToElement()->SetAttribute("x",sUvMapMinX.c_str());
-		Ogre::String sUvMapMinY = Ogre::StringConverter::toString(this->getBillboardUVMapMin(iBillboardGroup).y);
+		Ogre::String sUvMapMinY = Ogre::StringConverter::toString(this->getBillboardUVMapMin(0).y);
 		uvMapMin->ToElement()->SetAttribute("y",sUvMapMinY.c_str());
 
 		uvMapMax = billboardNode->ToElement()->InsertEndChild(TiXmlElement("uvMapMax"))->ToElement();
-		Ogre::String suvMapMaxX = Ogre::StringConverter::toString(this->getBillboardUVMapMax(iBillboardGroup).x);
+		Ogre::String suvMapMaxX = Ogre::StringConverter::toString(this->getBillboardUVMapMax(0).x);
 		uvMapMax->ToElement()->SetAttribute("x",suvMapMaxX.c_str());
-		Ogre::String suvMapMaxY = Ogre::StringConverter::toString(this->getBillboardUVMapMax(iBillboardGroup).y);
+		Ogre::String suvMapMaxY = Ogre::StringConverter::toString(this->getBillboardUVMapMax(0).y);
 		uvMapMax->ToElement()->SetAttribute("y",suvMapMaxY.c_str());
 	}
@@ -209,6 +221,5 @@
 
 void BillboardKMeansClusterData::generateBillboardBoundingQuad() 
-{
-	
+{	
 	Ogre::Vector3 normal = getNormal();
 	Ogre::Vector3 planePosition;
@@ -333,4 +344,18 @@
 		}		
 	}
+	
+	for (unsigned int iLeaf = 0; iLeaf < entityCluster->getNumEntitiesClusterData(); iLeaf++)
+	{
+		LeafKMeansClusterData *leafKMeansClusterData = (LeafKMeansClusterData*)entityCluster->getEntityClusterData(iLeaf).get();
+		Leaf *leaf = (Leaf*)leafKMeansClusterData->getEntity().get();		
+
+		Ogre::Vector3 position = leaf->getPosition();
+		Ogre::Vector4 projPointP1d4 =  Ogre::Vector4(position.x,position.y,position.z,1.0f) * invMCoordPlane * constCoord * coordPlane;
+		
+		// The point projected in the plane
+		Ogre::Vector3 projPointP1(projPointP1d4.x,projPointP1d4.y,projPointP1d4.z);
+
+		leaf->setPosition(projPointP1);
+	}
 
 	Ogre::Vector3 aP;
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IMGCluster.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IMGCluster.cpp	(revision 731)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IMGCluster.cpp	(revision 751)
@@ -110,10 +110,10 @@
 void Cluster::print() 
 {
-	Ogre::LogManager::getSingleton().logMessage("\n\nCluster: " + Ogre::StringConverter::toString(id) + ", axisproj: " + Ogre::StringConverter::toString(axisproj)  + ", order: " + Ogre::StringConverter::toString(order));
+	//Ogre::LogManager::getSingleton().logMessage("\n\nCluster: " + Ogre::StringConverter::toString(id) + ", axisproj: " + Ogre::StringConverter::toString(axisproj)  + ", order: " + Ogre::StringConverter::toString(order));
 	
 	plane.print();
-	Ogre::LogManager::getSingleton().logMessage("\nOrigin (" + Ogre::StringConverter::toString(lumel_origin) + ")");
-	Ogre::LogManager::getSingleton().logMessage("Inc U (" + Ogre::StringConverter::toString(lumel_x_axis) + ")");
-	Ogre::LogManager::getSingleton().logMessage("Inc V (" + Ogre::StringConverter::toString(lumel_y_axis.z) + ")");
+	//Ogre::LogManager::getSingleton().logMessage("\nOrigin (" + Ogre::StringConverter::toString(lumel_origin) + ")");
+	//Ogre::LogManager::getSingleton().logMessage("Inc U (" + Ogre::StringConverter::toString(lumel_x_axis) + ")");
+	//Ogre::LogManager::getSingleton().logMessage("Inc V (" + Ogre::StringConverter::toString(lumel_y_axis.z) + ")");
 	
 	bound.print();
@@ -121,5 +121,5 @@
 	bspnodebound.print();
 	
-	Ogre::LogManager::getSingleton().logMessage("Printant els vertexs: ");
+	//Ogre::LogManager::getSingleton().logMessage("Printant els vertexs: ");
 }
 
@@ -145,5 +145,5 @@
 void Cluster::finish() 
 {
-	Ogre::LogManager::getSingleton().logMessage("\nCluster::Finish()");
+	//Ogre::LogManager::getSingleton().logMessage("\nCluster::Finish()");
 	Plane3 *plane = getPlane();
 	Ogre::Vector3 normal = *plane->getNormal();
@@ -157,7 +157,7 @@
 	bool type = true;
 
-	Ogre::LogManager::getSingleton().logMessage("\tCreant cluster 2d");
+	//Ogre::LogManager::getSingleton().logMessage("\tCreant cluster 2d");
 	axisproj = cluster2d.create2d (this, 0, true);	
-	Ogre::LogManager::getSingleton().logMessage("\t Imprimint el que hi al del cluster");
+	//Ogre::LogManager::getSingleton().logMessage("\t Imprimint el que hi al del cluster");
 		
 	std::vector<Ogre::Vector2> vector2;
@@ -172,10 +172,10 @@
 	max = bound.getMaximum();
 	
-	Ogre::LogManager::getSingleton().logMessage("Caixa Englobant del cluster 2d");
+	//Ogre::LogManager::getSingleton().logMessage("Caixa Englobant del cluster 2d");
 	bound.print();
 
 	Ogre::Vector3 aux (-9999,-9999,-9999);
 
-	Ogre::LogManager::getSingleton().logMessage("Axisproj:" + Ogre::StringConverter::toString(axisproj));
+	//Ogre::LogManager::getSingleton().logMessage("Axisproj:" + Ogre::StringConverter::toString(axisproj));
 }
 
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IMGTextureAtlas.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IMGTextureAtlas.cpp	(revision 747)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IMGTextureAtlas.cpp	(revision 751)
@@ -87,5 +87,5 @@
 }
 
-void TextureAtlas::create(Ogre::String fileName, unsigned int width, unsigned int height, Ogre::PixelFormat pixelFormat, Ogre::Camera *camera)
+void TextureAtlas::create(Ogre::String fileName, unsigned int width, unsigned int height, Ogre::PixelFormat pixelFormat, Ogre::Camera *camera, Ogre::ColourValue backgroundColour)
 {
 	mCamera = camera;
@@ -101,5 +101,5 @@
 		Ogre::Viewport *v = rt->addViewport(mCamera);
 		v->setClearEveryFrame(true);
-		v->setBackgroundColour(Ogre::ColourValue(1.0f, 1.0f, 1.0f, 0.0f));
+		v->setBackgroundColour(backgroundColour);
 		v->setOverlaysEnabled(false);
 		v->setDimensions(0,0,1.0,1.0);	
@@ -113,5 +113,5 @@
 		Ogre::Viewport *v = rt->addViewport(mCamera);
 		v->setClearEveryFrame(true);
-		v->setBackgroundColour(Ogre::ColourValue(1.0f, 1.0f, 1.0f, 0.0f));
+		v->setBackgroundColour(backgroundColour);
 		v->setOverlaysEnabled(false);
 		v->setDimensions(0,0,1.0,1.0);	
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/BBCBillboardCloud.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/BBCBillboardCloud.cpp	(revision 745)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/BBCBillboardCloud.cpp	(revision 751)
@@ -237,64 +237,70 @@
 			unsigned int billboardHandle = billboardGroup->getBillboardHandle(iBillboard);
 			BillboardPtr billboard = this->getBillboard(billboardHandle);
-			EntityClusterPtr entityCluster = billboard->getBillboardClusterData()->getEntityCluster();
-
-			if (entityCluster->getNumEntitiesClusterData() > 0)
-			{
-				subEntity = mEntity->getSubEntity(numGeneratedBillboardClouds);
-
-				while (subEntityGroup->getNumTexCoordSets() < subEntity->getNumTexCoordSets())
+
+			BillboardClusterData *billboardClusterData = billboard->getBillboardClusterData().get();
+
+			if (billboardClusterData != NULL)
+			{				
+				EntityClusterPtr entityCluster = billboardClusterData->getEntityCluster();
+
+				if (entityCluster->getNumEntitiesClusterData() > 0)
 				{
-					subEntityGroup->addTextureCoordSet(subEntity->getTexCoordDimensions(subEntityGroup->getNumTexCoordSets()));
+					subEntity = mEntity->getSubEntity(numGeneratedBillboardClouds);
+
+					while (subEntityGroup->getNumTexCoordSets() < subEntity->getNumTexCoordSets())
+					{
+						subEntityGroup->addTextureCoordSet(subEntity->getTexCoordDimensions(subEntityGroup->getNumTexCoordSets()));
+					}
+
+					unsigned int offset = subEntityGroup->getNumFaces() * 3;
+					Ogre::Vector3 indicesA = Ogre::Vector3(offset, offset + 1, offset + 2);
+					subEntityGroup->addFaceVerticesIDs(indicesA);
+					offset = subEntityGroup->getNumFaces()*3;
+					Ogre::Vector3 indicesB = Ogre::Vector3(offset, offset + 1, offset + 2);
+					subEntityGroup->addFaceVerticesIDs(indicesB);
+
+					UniqueVertex vFaceA1,vFaceA2,vFaceA3;
+					// Face A of the billboard quad
+					vFaceA1.position = billboard->getBillboardClusterData()->getQuadTopLeftCorner();
+					vFaceA1.normal = billboard->getBillboardClusterData()->getNormal();
+
+					vFaceA2.position = billboard->getBillboardClusterData()->getQuadTopRightCorner();
+					vFaceA2.normal = billboard->getBillboardClusterData()->getNormal();
+					
+					vFaceA3.position = billboard->getBillboardClusterData()->getQuadBottomRightCorner();
+					vFaceA3.normal = billboard->getBillboardClusterData()->getNormal();
+					
+					// Face B of the billboard quad
+					UniqueVertex vFaceB1,vFaceB2,vFaceB3;
+					vFaceB1.position = billboard->getBillboardClusterData()->getQuadBottomRightCorner();
+					vFaceB1.normal = billboard->getBillboardClusterData()->getNormal();
+					
+					vFaceB2.position = billboard->getBillboardClusterData()->getQuadBottomLeftCorner();
+					vFaceB2.normal = billboard->getBillboardClusterData()->getNormal();
+					
+					vFaceB3.position = billboard->getBillboardClusterData()->getQuadTopLeftCorner();
+					vFaceB3.normal = billboard->getBillboardClusterData()->getNormal();
+					
+					Ogre::LogManager::getSingleton().logMessage("BBCG-SubEntity(" + Ogre::StringConverter::toString(numGeneratedBillboardClouds) + ") - Num.Tex.Coord.Sets:"+ Ogre::StringConverter::toString(subEntity->getNumTexCoordSets()));
+
+					for (unsigned int iTexCoordSet = 0; iTexCoordSet < subEntityGroup->getNumTexCoordSets(); iTexCoordSet++)
+					{					
+						vFaceA1.uv[iTexCoordSet] = subEntity->getUniqueVertex(0).uv[iTexCoordSet];
+						vFaceA2.uv[iTexCoordSet] = subEntity->getUniqueVertex(1).uv[iTexCoordSet];
+						vFaceA3.uv[iTexCoordSet] = subEntity->getUniqueVertex(2).uv[iTexCoordSet];
+						vFaceB1.uv[iTexCoordSet] = subEntity->getUniqueVertex(3).uv[iTexCoordSet];
+						vFaceB2.uv[iTexCoordSet] = subEntity->getUniqueVertex(4).uv[iTexCoordSet];
+						vFaceB3.uv[iTexCoordSet] = subEntity->getUniqueVertex(5).uv[iTexCoordSet];
+					}
+
+					subEntityGroup->addUniqueVertex(vFaceA1);
+					subEntityGroup->addUniqueVertex(vFaceA2);
+					subEntityGroup->addUniqueVertex(vFaceA3);
+					subEntityGroup->addUniqueVertex(vFaceB1);
+					subEntityGroup->addUniqueVertex(vFaceB2);
+					subEntityGroup->addUniqueVertex(vFaceB3);
+
+					numGeneratedBillboardClouds++;
 				}
-
-				unsigned int offset = subEntityGroup->getNumFaces() * 3;
-				Ogre::Vector3 indicesA = Ogre::Vector3(offset, offset + 1, offset + 2);
-				subEntityGroup->addFaceVerticesIDs(indicesA);
-				offset = subEntityGroup->getNumFaces()*3;
-				Ogre::Vector3 indicesB = Ogre::Vector3(offset, offset + 1, offset + 2);
-				subEntityGroup->addFaceVerticesIDs(indicesB);
-
-				UniqueVertex vFaceA1,vFaceA2,vFaceA3;
-				// Face A of the billboard quad
-				vFaceA1.position = billboard->getBillboardClusterData()->getQuadTopLeftCorner();
-				vFaceA1.normal = billboard->getBillboardClusterData()->getNormal();
-
-				vFaceA2.position = billboard->getBillboardClusterData()->getQuadTopRightCorner();
-				vFaceA2.normal = billboard->getBillboardClusterData()->getNormal();
-				
-				vFaceA3.position = billboard->getBillboardClusterData()->getQuadBottomRightCorner();
-				vFaceA3.normal = billboard->getBillboardClusterData()->getNormal();
-				
-				// Face B of the billboard quad
-				UniqueVertex vFaceB1,vFaceB2,vFaceB3;
-				vFaceB1.position = billboard->getBillboardClusterData()->getQuadBottomRightCorner();
-				vFaceB1.normal = billboard->getBillboardClusterData()->getNormal();
-				
-				vFaceB2.position = billboard->getBillboardClusterData()->getQuadBottomLeftCorner();
-				vFaceB2.normal = billboard->getBillboardClusterData()->getNormal();
-				
-				vFaceB3.position = billboard->getBillboardClusterData()->getQuadTopLeftCorner();
-				vFaceB3.normal = billboard->getBillboardClusterData()->getNormal();
-				
-				Ogre::LogManager::getSingleton().logMessage("BBCG-SubEntity(" + Ogre::StringConverter::toString(numGeneratedBillboardClouds) + ") - Num.Tex.Coord.Sets:"+ Ogre::StringConverter::toString(subEntity->getNumTexCoordSets()));
-
-				for (unsigned int iTexCoordSet = 0; iTexCoordSet < subEntityGroup->getNumTexCoordSets(); iTexCoordSet++)
-				{					
-					vFaceA1.uv[iTexCoordSet] = subEntity->getUniqueVertex(0).uv[iTexCoordSet];
-					vFaceA2.uv[iTexCoordSet] = subEntity->getUniqueVertex(1).uv[iTexCoordSet];
-					vFaceA3.uv[iTexCoordSet] = subEntity->getUniqueVertex(2).uv[iTexCoordSet];
-					vFaceB1.uv[iTexCoordSet] = subEntity->getUniqueVertex(3).uv[iTexCoordSet];
-					vFaceB2.uv[iTexCoordSet] = subEntity->getUniqueVertex(4).uv[iTexCoordSet];
-					vFaceB3.uv[iTexCoordSet] = subEntity->getUniqueVertex(5).uv[iTexCoordSet];
-				}
-
-				subEntityGroup->addUniqueVertex(vFaceA1);
-				subEntityGroup->addUniqueVertex(vFaceA2);
-				subEntityGroup->addUniqueVertex(vFaceA3);
-				subEntityGroup->addUniqueVertex(vFaceB1);
-				subEntityGroup->addUniqueVertex(vFaceB2);
-				subEntityGroup->addUniqueVertex(vFaceB3);
-
-				numGeneratedBillboardClouds++;
 			}
 		}
